
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

{$R-}
unit minihuff;

(* Mthodes
      Compression normale   : 0
      Compression variation : 1
*)

INTERFACE

procedure RDEZIP(sname:string; dseg,dofs:word);


IMPLEMENTATION
type Tsigne=array [0..3] of char;
     Pnoeud=^Tnoeud;
     Tnoeud=record
              carac:byte;
              cumul:longint;
              Fdroit,Fgauche:Pnoeud;
            end;
const signature:Tsigne='RZIP';
      buffer_size=10000;
var sfic:file;
(*** THA HEADER ***)
    signe:Tsigne;
    method:word;
    frequence:array [0..255] of longint;
    fsize:longint;
(*** END HEADER ***)
    buffer_read:array [1..buffer_size] of byte;
    pos_read,pos_writ,numread:word;
    arbre:Pnoeud;
    old:byte; (* pour variation method *)

procedure make_arbre;
var tab:array [0..255] of Pnoeud;
    temp:Pnoeud;
    tab_size:integer;
    i,j,k:byte;
begin
(*** initialize ze tableau ***)
  tab_size:=0;
  for i:=0 to 255 do if frequence[i]>0 then begin
    new(tab[tab_size]);
    with tab[tab_size]^ do begin
      carac:=i;
      cumul:=frequence[i];
      Fgauche:=nil;
      Fdroit:=nil;
    end;
    inc(tab_size);
  end;
  dec(tab_size);
(*** Tri ***)
  for i:=0 to tab_size do begin
    j:=i;
    for k:=i+1 to tab_size do if tab[k]^.cumul>tab[j]^.cumul then j:=k;
    temp:=tab[i];
    tab[i]:=tab[j];
    tab[j]:=temp;
  end;
(*** Make za arbre ***)
  while tab_size>0 do begin
    dec(tab_size);
    new(temp);
    temp^.Fgauche:=tab[tab_size];
    temp^.Fdroit :=tab[tab_size+1];
    temp^.cumul  :=tab[tab_size]^.cumul+tab[tab_size+1]^.cumul;
    tab[tab_size]:=temp;
(*** Find place and swap ***)
    for i:=0 to tab_size do begin
      j:=i;
      for k:=i+1 to tab_size do if tab[k]^.cumul>tab[j]^.cumul then j:=k;
      temp:=tab[i];
      tab[i]:=tab[j];
      tab[j]:=temp;
    end;
    {30.59
    i:=0;
    while (temp^.cumul<tab[i]^.cumul) and (i<tab_size) do inc(i);
(*** i=tab_size ou i=position a inserer ***)
    for j:=tab_size downto i+1 do tab[j]:=tab[j-1];
    tab[i]:=temp;}
  end;
(*** TAB[0] iz it !!! ***)
  arbre:=tab[0];
end;

procedure RDEZIP(sname:string; dseg,dofs:word);
var bits,cur_read_bit:byte;
    cur_code:Pnoeud;
begin
  assign(sfic,sname);
{$i-}
  reset(sfic,1);
{$i+}
  if ioresult<>0 then exit;
(*** Read za header ***)
  blockread(sfic,signe,4+2);
  if (signe<>signature) or not (method in [0..1]) then begin
    close(sfic);
    exit;
  end;
  blockread(sfic,frequence,256*4+4);
  make_arbre;
(*** GO ***)
  cur_code:=arbre;
  pos_writ:=0;
  old:=0;
  repeat
    blockread(sfic,buffer_read,buffer_size,numread);
    for pos_read:=1 to numread do begin
      bits:=128;
      for cur_read_bit:=0 to 7 do begin
        if bits and buffer_read[pos_read]=0 then cur_code:=cur_code^.fgauche
                                            else cur_code:=cur_code^.fdroit;
        bits:=bits shr 1;
        if cur_code^.fgauche=nil then begin
          if method=0 then mem[dseg:dofs+pos_writ]:=cur_code^.carac
                      else begin
                             mem[dseg:dofs+pos_writ]:=old-cur_code^.carac;
                             old:=old-cur_code^.carac;
                           end;
          inc(pos_writ);
          cur_code:=arbre;
        end;
      end;
    end;
  until numread<buffer_size;
  close(sfic);
end;

end.