
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

unit mode13;

interface
type Tpalette=array [0..767] of byte;
const trnscol=0;
      scrn_pg=ptr($A000,0);
var pal:Tpalette;
procedure setpal;
procedure init_mode13;
procedure close_mode13;
procedure copypage(source,dest:pointer);
procedure copyflip(source,dest:pointer);
procedure clearpage(page:pointer);
procedure copyblock(x,y:word; source:pointer; xs,ys:word; dest:pointer; xd,yd:word; mask,xflip,yflip:boolean);
procedure putpixel(page:pointer;x,y:word;col:byte);
procedure waitretrace;
function getpixel(page:pointer; x,y:word):byte;
procedure outtextxy(page:pointer; x,y:word; mot:string; col,xt,yt:byte);
procedure flou(page:pointer; deb,size,pas:word; dec:integer);


implementation

procedure init_mode13; assembler;              {initialise le mode 13.}
asm
  mov ax,13h
  int 10h
end;

procedure close_mode13; assembler;
asm
  mov ax,03h
  int 10h
end;

procedure copypage(source,dest:pointer); assembler;
asm
  push ds
  lds si,source
  les di,dest
  mov cx,320*200/4
  db 66h;rep movsw
  pop ds
end;

procedure copyflip(source,dest:pointer); assembler;
asm
  push ds
  lds si,source
  les di,dest
  mov di,320*200
  @boucle:
    sub di,320
    mov cx,320/4
    db 66h;rep movsw
    sub di,320
  jnz @boucle
  pop ds
end;

procedure clearpage(page:pointer); assembler;
asm
  les di,page
  mov cx,03E80h
  db 66h;xor ax,ax
  db 66h;rep stosw
end;

procedure copyblock(x,y:word; source:pointer; xs,ys:word; dest:pointer; xd,yd:word; mask,xflip,yflip:boolean); assembler;
(* Za big copyblock routine !!!
   Implemented :  block
                  block yflip
                  block mask
                  block mask xflip *)
asm
  push ds

  cmp x,0
  je @fin
  cmp y,0
  je @fin

  lds si,source
  les di,dest

  mov ax,yd
  shl ax,6
  add di,ax
  shl ax,2
  add di,ax
  add di,xd

  mov ax,ys
  shl ax,6
  add si,ax
  shl ax,2
  add si,ax
  add si,xs

  mov bx,320
  sub bx,x                  {met dans bx le dcalage de fin de ligne.}
  mov cx,y                  {met dans le compteur cx la largeur y.}

  cmp mask,false            {si masque est faux, on saute  la sous-procedure}
  je @sprite                {putsprite...}

@block:
  cmp yflip,true
  je @block_yflip

  cmp xflip,true
  je @boucle2

  (* Block Normal *)
  @boucle1:
    push cx
    mov cx,x
    mov dx,cx
    shr cx,2
    db 66h;rep movsw
    mov cx,dx
    and cx,3
    rep movsb
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @boucle1
  jmp @fin

  (* Block Xflip *)
  @boucle2:
  jmp @fin

  (* Block Yflip *)
  @block_yflip:
    dec cx
    mov ax,320
    mul cx
    add si,ax
    inc cx
  @boucle3:
    push cx
    mov cx,x
    mov dx,cx
    shr cx,2
    db 66h;rep movsw
    mov cx,dx
    and cx,3
    rep movsb
    add di,bx
    sub si,320
    sub si,x
    pop cx
    dec cx
  jnz @boucle3
  jmp @fin

@sprite:
  cmp xflip,false
  je @sprite2

  (* Sprite Xflip *)
  add di,x
  @sprite1:
    push cx
    mov cx,x
    @line1:
      mov ah,ds:[si]
      or ah,ah
      je @noir1
      cmp ah,85
      je @noir1
      mov es:[di],ah
      @noir1:
      dec di
      inc si
      dec cx
    jnz @line1
    add di,320
    add di,x
    add si,320
    sub si,x
    pop cx
    dec cx
  jnz @sprite1
  jmp @fin

  (* Sprite Normal *)
  @sprite2:
    push cx
    mov cx,x
    @line2:
      mov ah,ds:[si]
      or ah,ah
      je @noir2
      cmp ah,85
      je @noir2
      mov es:[di],ah
      @noir2:
      inc di
      inc si
      dec cx
    jnz @line2
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @sprite2

  @fin:
  pop ds
end;

procedure putpixel(page:pointer;x,y:word;col:byte); assembler;
asm
 cmp col,trnscol
{ jz @transparent}
  les di,page
  mov ax,y
  shl ax,6
  mov di,ax
  shl ax,2
  add di,ax
  add di,x
  mov al,col
  mov es:[di],al
 @transparent:
end;

function getpixel(page:pointer; x,y:word):byte; assembler;
asm
  les di,page
  mov ax,y
  shl ax,6
  add di,ax
  shl ax,2
  add di,ax
  add di,x
  mov ax,es:[di]
end;

procedure waitretrace; assembler;
asm
  mov dx,3dah
@wait1:
  in al,dx
  test al,08h
  jnz @wait1
@wait2:
  in al,dx
  test al,08h
  jz @wait2
end;

procedure setpal; assembler;
asm
  cld
  xor di,di
  xor bx,bx
  @l1:
    mov dx,03c8h
    mov ax,bx
    out dx,al
    inc dx
    mov cx,3
    @l2:
      mov al,byte ptr pal[di]
      shr al,1
      shr al,1
      out dx,al
      inc di
    loop @l2
    inc bx
    cmp bx,256
  jne @l1
end;

procedure outtextxy(page:pointer; x,y:word; mot:string; col,xt,yt:byte);
type poltyp=array [0..255,0..13] of byte;
     polptr=^poltyp;
const police:polptr=nil;
var xpnt,ypnt,xpol,ypol,poss,temp:byte;
begin
  if police=nil then asm
    push bp
    mov ax,1130h
    mov bh,2
    int 10h
    mov word ptr [police],bp
    mov word ptr [police+2],es
    pop bp
  end;
  for poss:=1 to length(mot) do
     for ypol:=0 to 13 do begin
      temp:=police^[ord(mot[poss]),ypol];
      for xpol:=0 to 7 do begin
        if (temp and 128<>0) then
        for xpnt:=1 to xt do
          for ypnt:=1 to yt do
            putpixel(page,x+(xpol+(poss-1)*8)*xt+xpnt,y+ypol*yt+ypnt,col);
        temp:=temp shl 1
      end;
    end;
end;

procedure flou(page:pointer; deb,size,pas:word; dec:integer); assembler;
asm
  les di,page
  add di,deb
  mov cx,size
@boucle:
  xor ax,ax
  add al,es:[di-1]
  add al,es:[di+1]
  adc ah,0
  add al,es:[di-320]
  adc ah,0
  add al,es:[di+320]
  adc ah,0
  cmp ax,pas
  jb @nopas
  sub ax,pas
@nopas:
  mov dl,4
  div dl
  mov si,di
  add si,dec
  mov es:[si],al
  inc di
loop @boucle
end;



end.